 /* Letzte nderung: 14.05.02 09:18 */

 /* Primitive types: */ /**/
 define alias jboolean unsigned fixed bin (8);
 define alias jbyte    signed fixed bin (7);
 define alias jchar    unsigned fixed bin (16);
 define alias jshort   fixed bin (15);
 define alias jint     fixed bin (31);
 define alias jlong    fixed bin (63);
 define alias jfloat   float bin (21);
 define alias jdouble  float bin (53);
 define alias jsize    type jint;

 /* Reference types: */ /**/
 define alias jobject       ptr;
 define alias jclass        type jobject;
 define alias jthrowable    type jobject;
 define alias jstring       type jobject;
 define alias jvoid         type jobject;
 define alias jfieldID      type jobject;
 define alias jmethodID     type jobject;
 define alias jarray        type jobject;
 define alias jbooleanArray type jarray;
 define alias jbyteArray    type jarray;
 define alias jcharArray    type jarray;
 define alias jshortArray   type jarray;
 define alias jintArray     type jarray;
 define alias jlongArray    type jarray;
 define alias jfloatArray   type jarray;
 define alias jdoubleArray  type jarray;
 define alias jobjectArray  type jarray;

 /* Konstanten: */ /**/
 dcl JNI_FALSE fixed bin (31) value (0);
 dcl JNI_TRUE  fixed bin (31) value (1);

 /* Interface function table: */ /**/
 define structure
     1 JNINativeInterface,
        2 * ptr,
        2 * ptr,
        2 * ptr,
        2 * ptr,
        2 GetVersion limited entry
          (ptr byaddr)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 DefineClass limited entry
          (ptr byaddr, ptr byvalue, ptr byvalue,
            fixed bin (31))
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jclass),
        2 FindClass limited entry
          (ptr byaddr, nonasgn char (*) varz)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jclass),
        2 * ptr,
        2 * ptr,
        2 * ptr,
        2 GetSuperClass limited entry
          (ptr byaddr, type jclass)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jclass),
        2 IsAssignableFrom limited entry
          (ptr byaddr, type jclass, type jclass)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 * ptr,
        2 Throw limited entry
          (ptr byaddr, type jthrowable)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 ThrowNew limited entry
          (ptr byaddr, type jclass, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),

        2 ExceptionOccurred limited entry
          (ptr byaddr)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jthrowable),
        2 ExceptionDescribe limited entry
          (ptr byaddr)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue ptr byvalue optional),
        2 ExceptionClear limited entry
          (ptr byaddr)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue ptr byvalue optional),

        2 FatalError limited entry
          (ptr byaddr, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue ptr byvalue optional),
        2 * ptr,
        2 * ptr,

        2 NewGlobalRef limited entry
          (ptr byaddr, type jobject)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 DeleteGlobalRef limited entry
          (ptr byaddr, type jobject)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue ptr byvalue optional),
        2 DeleteLocalRef limited entry
          (ptr byaddr, type jobject)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue ptr byvalue optional),

        2 IsSameObject limited entry
          (ptr byaddr, type jobject, type jobject)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 * ptr,
        2 * ptr,

        2 AllocObject limited entry
          (ptr byaddr, type jclass)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),

        2 NewObject limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 NewObjectV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 NewObjectA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),

        2 GetObjectClass limited entry
         (ptr byaddr, type jobject)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jclass),
        2 IsInstanceOf limited entry
          (ptr byaddr, type jobject, type jclass)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 GetMethodID limited entry
          (ptr byaddr, type jclass,
            nonasgn char (*) varz, nonasgn char (*) varz)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jmethodID),

        2 CallObjectMethod limited entry
          (ptr byaddr, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 CallObjectMethodV limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 CallObjectMethodA limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),

        2 CallBooleanMethod limited entry
          (ptr byaddr, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 CallBooleanMethodV limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 CallBooleanMethodA limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),

        2 CallByteMethod limited entry
          (ptr byaddr, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),
        2 CallByteMethodV limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),
        2 CallByteMethodA limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),

        2 CallCharMethod limited entry
          (ptr byaddr, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),
        2 CallCharMethodV limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),
        2 CallCharMethodA limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),

        2 CallShortMethod limited entry
          (ptr byaddr, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),
        2 CallShortMethodV limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),
        2 CallShortMethodA limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),

        2 CallIntMethod limited entry
          (ptr byaddr, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 CallIntMethodV limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 CallIntMethodA limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),

        2 CallLongMethod limited entry
          (ptr byaddr, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),
        2 CallLongMethodV limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),
        2 CallLongMethodA limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),

        2 CallFloatMethod limited entry
          (ptr byaddr, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),
        2 CallFloatMethodV limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),
        2 CallFloatMethodA limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),

        2 CallDoubleMethod limited entry
          (ptr byaddr, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),
        2 CallDoubleMethodV limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),
        2 CallDoubleMethodA limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),

        2 CallVoidMethod limited entry
          (ptr byaddr, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 CallVoidMethodV limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 CallVoidMethodA limited entry
          (ptr byaddr, type jobject, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),

        2 CallNonVirtualObjectMethod limited entry
          (ptr byaddr, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 CallNonVirtualObjectMethodV limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 CallNonVirtualObjectMethodA limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),

        2 CallNonVirtualBooleanMethod limited entry
          (ptr byaddr, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 CallNonVirtualBooleanMethodV limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 CallNonVirtualBooleanMethodA limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),

        2 CallNonVirtualByteMethod limited entry
          (ptr byaddr, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),
        2 CallNonVirtualByteMethodV limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),
        2 CallNonVirtualByteMethodA limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),

        2 CallNonVirtualCharMethod limited entry
          (ptr byaddr, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),
        2 CallNonVirtualCharMethodV limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),
        2 CallNonVirtualCharMethodA limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),

        2 CallNonVirtualShortMethod limited entry
          (ptr byaddr, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),
        2 CallNonVirtualShortMethodV limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),
        2 CallNonVirtualShortMethodA limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),

        2 CallNonVirtualIntMethod limited entry
          (ptr byaddr, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 CallNonVirtualIntMethodV limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 CallNonVirtualIntMethodA limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),

        2 CallNonVirtualLongMethod limited entry
          (ptr byaddr, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),
        2 CallNonVirtualLongMethodV limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),
        2 CallNonVirtualLongMethodA limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),

        2 CallNonVirtualFloatMethod limited entry
          (ptr byaddr, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),
        2 CallNonVirtualFloatMethodV limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),
        2 CallNonVirtualFloatMethodA limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),

        2 CallNonVirtualDoubleMethod limited entry
          (ptr byaddr, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),
        2 CallNonVirtualDoubleMethodV limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),
        2 CallNonVirtualDoubleMethodA limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),

        2 CallNonVirtualVoidMethod limited entry
          (ptr byaddr, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 CallNonVirtualVoidMethodV limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 CallNonVirtualVoidMethodA limited entry
          (ptr byaddr, type jobject, type jclass,
            type jmethodID, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),

        2 GetFieldID limited entry
          (ptr byaddr, type jclass,
            byaddr nonasgn char (*) varz,
            byaddr nonasgn char (*) varz)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfieldID),

        2 GetObjectField limited entry
          (ptr byaddr, type jobject, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 GetBooleanField limited entry
          (ptr byaddr, type jobject, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 GetByteField limited entry
          (ptr byaddr, type jobject, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),
        2 GetCharField limited entry
          (ptr byaddr, type jobject, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),
        2 GetShortField limited entry
          (ptr byaddr, type jobject, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),
        2 GetIntField limited entry
          (ptr byaddr, type jobject, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 GetLongField limited entry
          (ptr byaddr, type jobject, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),
        2 GetFloatField limited entry
          (ptr byaddr, type jobject, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),
        2 GetDoubleField limited entry
          (ptr byaddr, type jobject, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),

        2 SetObjectField limited entry
          (ptr byaddr, type jobject, type jfieldID,
            type jobject)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetBooleanField limited entry
          (ptr byaddr, type jobject, type jfieldID,
            type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetByteField limited entry
          (ptr byaddr, type jobject, type jfieldID,
            type jbyte)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetCharField limited entry
          (ptr byaddr, type jobject, type jfieldID,
            type jchar)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetShortField limited entry
          (ptr byaddr, type jobject, type jfieldID,
            type jshort)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetIntField limited entry
          (ptr byaddr, type jobject, type jfieldID,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue optional type jvoid),
        2 SetLongField limited entry
          (ptr byaddr, type jobject, type jfieldID,
            type jlong)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetFloatField limited entry
          (ptr byaddr, type jobject, type jfieldID,
            type jfloat)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetDoubleField limited entry
          (ptr byaddr, type jobject, type jfieldID,
            type jdouble)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),

        2 GetStaticMethodID limited entry
          (ptr byaddr, type jclass,
            nonasgn char (*) varz, nonasgn char (*) varz)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jmethodID),

        2 CallStaticObjectMethod limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 CallStaticObjectMethodV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 CallStaticObjectMethodA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),

        2 CallStaticBooleanMethod limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 CallStaticBooleanMethodV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 CallStaticBooleanMethodA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),

        2 CallStaticByteMethod limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),
        2 CallStaticByteMethodV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),
        2 CallStaticByteMethodA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),

        2 CallStaticCharMethod limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),
        2 CallStaticCharMethodV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),
        2 CallStaticCharMethodA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),

        2 CallStaticShortMethod limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),
        2 CallStaticShortMethodV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),
        2 CallStaticShortMethodA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),

        2 CallStaticIntMethod limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 CallStaticIntMethodV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 CallStaticIntMethodA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),

        2 CallStaticLongMethod limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),
        2 CallStaticLongMethodV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),
        2 CallStaticLongMethodA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),

        2 CallStaticFloatMethod limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),
        2 CallStaticFloatMethodV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),
        2 CallStaticFloatMethodA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),

        2 CallStaticDoubleMethod limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),
        2 CallStaticDoubleMethodV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),
        2 CallStaticDoubleMethodA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),

        2 CallStaticVoidMethod limited entry
          (ptr byaddr, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 CallStaticVoidMethodV limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 CallStaticVoidMethodA limited entry
          (ptr byaddr, type jclass, type jmethodID,
            ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),

        2 GetStaticFieldID limited entry
          (ptr byaddr, type jclass,
            nonasgn char (*) varz, nonasgn char (*) varz)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfieldID),
        2 GetStaticObjectField limited entry
          (ptr byaddr, type jclass, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 GetStaticBooleanField limited entry
          (ptr byaddr, type jclass, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 GetStaticByteField limited entry
          (ptr byaddr, type jclass, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),
        2 GetStaticCharField limited entry
          (ptr byaddr, type jclass, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),
        2 GetStaticShortField limited entry
          (ptr byaddr, type jclass, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),
        2 GetStaticIntField limited entry
          (ptr byaddr, type jclass, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 GetStaticLongField limited entry
          (ptr byaddr, type jclass, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),
        2 GetStaticFloatField limited entry
          (ptr byaddr, type jclass, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),
        2 GetStaticDoubleField limited entry
          (ptr byaddr, type jclass, type jfieldID)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),

        2 SetStaticObjectField limited entry
          (ptr byaddr, type jclass, type jfieldID,
            type jobject)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetStaticBooleanField limited entry
          (ptr byaddr, type jclass, type jfieldID,
            type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetStaticByteField limited entry
          (ptr byaddr, type jclass, type jfieldID,
            type jbyte)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetStaticCharField limited entry
          (ptr byaddr, type jclass, type jfieldID,
            type jchar)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetStaticShortField limited entry
          (ptr byaddr, type jclass, type jfieldID,
            type jshort)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetStaticIntField limited entry
          (ptr byaddr, type jclass, type jfieldID,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetStaticLongField limited entry
          (ptr byaddr, type jclass, type jfieldID,
            type jlong)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetStaticFloatField limited entry
          (ptr byaddr, type jclass, type jfieldID,
            type jfloat)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetStaticDoubleField limited entry
          (ptr byaddr, type jclass, type jfieldID,
            type jdouble)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),

        2 NewString limited entry
          (ptr byaddr, wchar (*) varz byaddr, type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jstring),
        2 GetStringLength limited entry
          (ptr byaddr, type jstring)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jsize),
        2 GetStringChars limited entry
          (ptr byaddr, type jstring, type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue ptr byvalue),
        2 ReleaseStringChars limited entry
          (ptr byaddr, type jstring, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),

        2 NewStringUTF limited entry
          (ptr byaddr, nonasgn char (*) varz)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jstring),
        2 GetStringUTFLength limited entry
          (ptr byaddr, type jstring)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jsize),
        2 GetStringUTFChars limited entry
          (ptr byaddr, type jstring, type jBoolean byaddr)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue ptr byvalue),
        2 ReleaseStringUTFChars limited entry
          (ptr byaddr, type jstring, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid optional),

        2 GetArrayLength limited entry
          (ptr byaddr, type jarray)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jsize),

        2 NewObjectArray limited entry
          (ptr byaddr, type jsize, type jclass,
            type jobject )
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobjectArray),
        2 GetObjectArrayElement limited entry
          (ptr byaddr, type jobjectArray, type jsize)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jobject),
        2 SetObjectArrayElement limited entry
          (ptr byaddr, type jobjectArray, type jsize,
            type jobject)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),

        2 NewBooleanArray limited entry
          (ptr byaddr, type jsize)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbooleanArray),
        2 NewByteArray limited entry
          (ptr byaddr, type jsize)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyteArray),
        2 NewCharArray limited entry
          (ptr byaddr, type jsize)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jcharArray),
        2 NewShortArray limited entry
          (ptr byaddr, type jsize)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshortArray),
        2 NewIntArray limited entry
          (ptr byaddr, type jsize)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jintArray),
        2 NewLongArray limited entry
          (ptr byaddr, type jsize)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlongArray),
        2 NewFloatArray limited entry
          (ptr byaddr, type jsize)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloatArray),
        2 NewDoubleArray limited entry
          (ptr byaddr, type jsize)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdoubleArray),

        2 GetBooleanArrayElements limited entry
          (ptr byaddr, type jbooleanArray, type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jboolean),
        2 GetByteArrayElements limited entry
          (ptr byaddr, type jbyteArray, type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jbyte),
        2 GetCharArrayElements limited entry
          (ptr byaddr, type jcharArray, type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jchar),
        2 GetShortArrayElements limited entry
          (ptr byaddr, type jshortArray, type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jshort),
        2 GetIntArrayElements limited entry
          (ptr byaddr, type jintArray, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue ptr byvalue),
        2 GetLongArrayElements limited entry
          (ptr byaddr, type jlongArray, type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jlong),
        2 GetFloatArrayElements limited entry
          (ptr byaddr, type jfloatArray, type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jfloat),
        2 GetDoubleArrayElements limited entry
          (ptr byaddr, type jdoubleArray, type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jdouble),

        2 ReleaseBooleanArrayElements limited entry
          (ptr byaddr, type jbooleanArray, type jboolean,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 ReleaseByteArrayElements limited entry
          (ptr byaddr, type jbyteArray, type jbyte,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 ReleaseCharArrayElements limited entry
          (ptr byaddr, type jcharArray, type jchar,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 ReleaseShortArrayElements limited entry
          (ptr byaddr, type jshortArray, type jshort,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 ReleaseIntArrayElements limited entry
          (ptr byaddr, type jintArray, type jint,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 ReleaseLongArrayElements limited entry
          (ptr byaddr, type jlongArray, type jlong,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 ReleaseFloatArrayElements limited entry
          (ptr byaddr, type jfloatArray, type jfloat,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 ReleaseDoubleArrayElements limited entry
          (ptr byaddr, type jdoubleArray, type jdouble,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),

        2 GetBooleanArrayRegion limited entry
          (ptr byaddr, type jbooleanArray, type jsize,
            type jsize, type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 GetByteArrayRegion limited entry
          (ptr byaddr, type jbyteArray, type jsize,
            type jsize, type jbyte)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 GetCharArrayRegion limited entry
          (ptr byaddr, type jcharArray, type jsize,
            type jsize, type jchar)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 GetShortArrayRegion limited entry
          (ptr byaddr, type jshortArray, type jsize,
            type jsize, type jshort)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 GetIntArrayRegion limited entry
          (ptr byaddr, type jintArray, type jsize,
            type jsize, type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 GetLongArrayRegion limited entry
          (ptr byaddr, type jlongArray, type jsize,
            type jsize, type jlong)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 GetFloatArrayRegion limited entry
          (ptr byaddr, type jfloatArray, type jsize,
            type jsize, type jfloat)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 GetDoubleArrayRegion limited entry
          (ptr byaddr, type jdoubleArray, type jsize,
            type jsize, type jdouble)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),

        2 SetBooleanArrayRegion limited entry
          (ptr byaddr, type jbooleanArray, type jsize,
            type jsize, type jboolean)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetByteArrayRegion limited entry
          (ptr byaddr, type jbyteArray, type jsize,
            type jsize, type jbyte)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetCharArrayRegion limited entry
          (ptr byaddr, type jcharArray, type jsize,
            type jsize, type jchar)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetShortArrayRegion limited entry
          (ptr byaddr, type jshortArray, type jsize,
            type jsize, type jshort)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetIntArrayRegion limited entry
          (ptr byaddr, type jintArray, type jsize,
            type jsize, type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetLongArrayRegion limited entry
          (ptr byaddr, type jlongArray, type jsize,
            type jsize, type jlong)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetFloatArrayRegion limited entry
          (ptr byaddr, type jfloatArray, type jsize,
            type jsize, type jfloat)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),
        2 SetDoubleArrayRegion limited entry
          (ptr byaddr, type jdoubleArray, type jsize,
            type jsize, type jdouble)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jvoid),

        2 RegisterNatives limited entry
          (ptr byaddr, type jclass, ptr byvalue,
            type jint)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 UnregisterNatives limited entry
          (ptr byaddr, type jclass)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),

        2 MonitorEnter limited entry
          (ptr byaddr, type jobject)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),
        2 MonitorExit limited entry
          (ptr byaddr, type jobject)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),

        2 GetJavaVM limited entry
          (ptr byaddr, ptr byvalue)
          options (byvalue nodescriptor linkage (system))
          returns (byvalue type jint),

        2 * dim (8) ptr,

        2 ExceptionCheck limited entry
          (ptr byaddr)
          options (nodescriptor linkage (system))
          returns (byvalue type jboolean);

 /**/
 dcl Env             type JNINativeInterface based (JNIEnv);
 dcl JNIEnv          ptr based (JNIEnvPtr);
 dcl JNIEnvPtr       ptr;

 /* Initialisierungsoptionen: */ /**/
 define structure
    1 JavaVMOption,
      2 optionStringPtr ptr,
      2 extraInfoPtr    ptr;
 define structure
    1 JavaVMInitArgs,
      2 version            type jint,
      2 nOptions           type jint,
      2 optionsPtr         ptr,
      2 ignoreUnrecognized type jboolean;

 /* Invokation API: */ /**/
 define structure
     1 JNIInvokeInterface,
       2 reserved0 ptr,
       2 reserved1 ptr,
       2 reserved2 ptr,
       2 JNI_DestroyJavaVM               limited entry (ptr)
         options (byvalue nodescriptor linkage (system))
         returns (byvalue optional type jint),
       2 JNI_AttachCurrentThread         limited entry,
       2 JNI_DetachCurrentThread         limited entry,
       2 JNI_GetEnv                      limited entry,
       2 JNI_AttachCurrentThreadAsDaemon limited entry;

 /**/
 dcl VM              type JNIInvokeInterface based (JavaVM);
 dcl JavaVM          ptr based (JavaVMPtr);
 dcl JavaVMPtr       ptr;

 /**/
 dcl JNI_CreateJavaVM entry
     (ptr, ptr, type JavaVMInitArgs)
     ext ('JNI_CreateJavaVM')
     options (byaddr nodescriptor linkage (stdcall))
     returns (byvalue optional type jint);

 %java_handle_exception: /*********************************************/
 procedure (Describe, Clear) stmt;

 dcl (Describe, Clear) char;

 ans ("do;")                                                skip noscan;
 if parmset(Describe) then
    ans ("call Env.ExceptionDescribe (JNIEnv);")            skip noscan;
 if parmset(Describe) then
    ans ("call Env.ExceptionClear (JNIEnv);")               skip noscan;
 ans ("end;")                                               skip noscan;

 %end java_handle_exception;
 %act java_handle_exception;

 %java_start: /********************************************************/
 procedure (Options) stmt;

 dcl Options char;
 dcl I fixed;

 ans ("begin;")                                             skip noscan;
 ans ("on underflow;")                                      skip noscan;
 ans ("dcl I fixed bin (31);")                              skip noscan;
 ans ("dcl Vm_args type JavaVMInitArgs;")                   skip noscan;
 ans ("dcl Options dim (dim(P)) type JavaVMOption;")        skip noscan;
 ans ("dcl P       dim (1)")                                skip noscan;
 ans ("            ptr static init to (varz)(")             skip noscan;
 ans (Options || ");")                                      skip noscan;
 ans ("do I = 1 to dim(P);")                                skip noscan;
 ans ("   Options(I).OptionStringPtr = P(I);")              skip noscan;
 ans ("   Options(I).extraInfoPtr = null();")               skip noscan;
 ans ("   end;")                                            skip noscan;
 ans ("Vm_args.version = '00010004'xn;")                    skip noscan;
 ans ("Vm_args.nOptions = dim(Options);" )                  skip noscan;
 ans ("Vm_args.optionsPtr = addr(Options);")                skip noscan;
 ans ("Vm_args.ignoreUnrecognized = JNI_FALSE;")            skip noscan;
 ans ("I = JNI_CreateJavaVM(JavaVMPtr,")                    skip noscan;
 ans ("                     JNIEnvPtr,")                    skip noscan;
 ans ("                     Vm_args);")                     skip noscan;
 ans ("if I ^= 0 then signal cond (Java_exception);")       skip noscan;

 ans ("end;")                                               skip noscan;

 %end java_start;
 %act java_start;

 %java_find_class: /***************************************************/
 procedure (Posparm, Classname) stmt;

 dcl (Posparm, Classname) char;

 ans ("do;")                                                skip noscan;
 ans (Posparm || " =  Env.FindClass(JNIEnv,")               skip noscan;
 ans ("translate(" || Classname || ", '/', '.'));")         skip noscan;
 ans ("if Env.ExceptionCheck(JNIEnv) = JNI_TRUE")           skip noscan;
 ans ("then signal cond (Java_exception);")                 skip noscan;
 ans ("end;")                                               skip noscan;

 %end java_find_class;
 %act java_find_class;

 %java_find_method: /**************************************************/
 procedure (Posparm, Class, Methodname, Constructor, Signature) stmt;

 dcl (Posparm, Class, Methodname, Constructor, Signature) char;

 ans ("do;")                                                skip noscan;
 ans (Posparm || " =  Env.GetMethodID(JNIEnv,")             skip noscan;
 ans (Class || ',')                                         skip noscan;
 if parmset(Constructor)
    then ans ("'<init>',")                                  skip noscan;
    else ans (Methodname || ',')                            skip noscan;
 ans ("translate(" || Signature || ", '/', '.'));")         skip noscan;
 ans ("if Env.ExceptionCheck(JNIEnv) = JNI_TRUE")           skip noscan;
 ans ("then signal cond (Java_exception);")                 skip noscan;
 ans ("end;")                                               skip noscan;

 %end java_find_method;
 %act java_find_method;

 %java_create_string: /************************************************/
 procedure (Posparm, Widechar, Char) stmt;

 dcl (Posparm, Widechar, Char) char;

 ans ("do;")                                                skip noscan;
 if parmset(Widechar)
    then do;
       ans (Posparm || " = Env.NewString(JNIEnv,")          skip noscan;
       ans (Widechar || ",")                                skip noscan;
       ans ("length(" || Widechar || ")*2);")               skip noscan;
       end;
    else do;
       ans (Posparm || " = Env.NewStringUTF(JNIEnv,")       skip noscan;
       ans (Char || ");")                                   skip noscan;
       end;
 ans ("if Env.ExceptionCheck(JNIEnv) = JNI_TRUE")           skip noscan;
 ans ("then signal cond (Java_exception);")                 skip noscan;
 ans ("end;")                                               skip noscan;

 %end java_create_string;
 %act java_create_string;

 %java_create_object: /************************************************/
 procedure (Posparm, Class, Methodname, MethodID, Parameter, Signature)
 stmt;

 dcl (Posparm, Class, Methodname, MethodID, Parameter, Signature) char;

 ans ("begin;")                                             skip noscan;
 ans ("dcl Javamethodid type jMethodID;")                   skip noscan;
 if parmset(MethodID)
    then
       ans ("Javamethodid = " || MethodID || ";")           skip noscan;
    else do;
       ans ("Javamethodid = Env.GetMethodID(JNIEnv,")       skip noscan;
       ans (Class || ',')                                   skip noscan;
       ans ("'<init>',")                                    skip noscan;
       ans ("translate(" || Signature || ", '/', '.'));")   skip noscan;
       ans ("if Env.ExceptionCheck(JNIEnv) = JNI_TRUE")     skip noscan;
       ans ("then signal cond (Java_exception);")           skip noscan;
       end;
 ans (Posparm || " =  Env.NewObject(JNIEnv,")               skip noscan;
 ans (Class || ",")                                         skip noscan;
 ans ("Javamethodid")                                       skip noscan;
 if parmset(Parameter) then
    ans ("," || Parameter)                                  skip noscan;
 ans (");")                                                 skip noscan;
 ans ("if Env.ExceptionCheck(JNIEnv) = JNI_TRUE")           skip noscan;
 ans ("then signal cond (Java_exception);")                 skip noscan;
 ans ("end;")                                               skip noscan;

 %end java_create_object;
 %act java_create_object;

 %java_call_result: /**************************************************/
 procedure (Posparm, Returns, Object, Method, Parameter) stmt;

 dcl (Posparm, Returns, Object, Method, Parameter) char;
 dcl Typ char;

 Typ = translate(substr(Returns, 2, 1), 'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
                                     'abcdefghijklmnopqrstuvwxyz')
       || substr(Returns, 3);

 ans ("do;")                                                skip noscan;
 ans (Posparm || " =  Env.Call" || Typ || "Method(JNIEnv,") skip noscan;
 ans (Object || ",")                                        skip noscan;
 ans (Method)                                               skip noscan;
 if parmset(Parameter) then
    ans ("," || Parameter)                                  skip noscan;
 ans (");")                                                 skip noscan;
 ans ("if Env.ExceptionCheck(JNIEnv) = JNI_TRUE")           skip noscan;
 ans ("then signal cond (Java_exception);")                 skip noscan;
 ans ("end;")                                               skip noscan;

 %end java_call_result;
 %act java_call_result;

 %java_stop: /*********************************************************/
 procedure stmt;

 ans ("begin;")                                             skip noscan;
 ans ("dcl I fixed bin (31);")                              skip noscan;
 ans ("I = VM.JNI_DestroyJavaVM(JavaVMPtr);")               skip noscan;
 ans ("if I ^= 0 then signal cond (Java_exception);")       skip noscan;
 ans ("end;")                                               skip noscan;

 %end java_stop;
 %act java_stop;
